#include <iostream>
#include <fstream>
#include <string.h>
#include <stdlib.h>
using namespace std;

const int MAXN = 100;
const int MAXP = 10;

enum Giorno {Lun, Mar, Mer, Gio, Ven, Sab, Dom};

enum Tipo {Colazione, Pranzo, Cena};

struct Alimento {
  char nome[MAXN];
  int calorie;
  int grammi;
};

struct Pasto {
  Alimento alim[MAXP];
  int numAlim;
};

typedef Pasto Dieta[3][7];

void stampa(const Dieta d, Giorno g);
Giorno piuCalorie(const Dieta d, Tipo t);
bool inserisci(Dieta d, Alimento p, Tipo t, Giorno g);
int quanteVolte(const Dieta d, const char n[]);
bool salva(const Dieta d, const char nomef[]);

bool carica(Dieta d, const char nf[]) {
  int i=0, j=0;
  Alimento p;
  fstream f;
  f.open(nf, ios::in);
  if(!f) return false;
  do {
    f >> p.nome;
    if(strcmp(p.nome, "#")==0)
      break;
    else if(strcmp(p.nome, "-")==0){
      if((Tipo)i == Cena) {
        i = Colazione;
        j++;
      } else i++;
      continue;
    }
    f >> p.calorie;
    f >> p.grammi;  
    if(!inserisci(d, p, (Tipo)i, (Giorno)j))
      return false;
  } while (f);
  return true;
}

void inizializza(Dieta d) {
  for(int i=Lun; i<=Dom; i++) {
    for(int j=Colazione; j<=Cena; j++) {
      d[j][i].numAlim = 0;
    }
  }
}

void menu(){
  cout << "#######################" << endl;
  cout << "1) inserisci" << endl;
  cout << "2) stampa giorno" << endl;
  cout << "3) piu' calorie" << endl;
  cout << "4) quante volte" << endl;
  cout << "5) salva ordinata" << endl;
  cout << "6) esci" << endl;
  cout << "scelta: ";
}

Tipo chiediTipo(){
  while(true) {
    cout << "Inserisci il tipo:" << endl;
    cout << "1) colazione" << endl;
    cout << "2) pranzo" << endl;
    cout << "3) cena" << endl;
    cout << "? ";
    char c;
    cin >> c;
    switch(c){
      case '1':
        return Colazione;
      case '2':
        return Pranzo;  
      case '3':
        return Cena;
      default:
        cout << "Scelta inesistente" << endl;
    }
  }
}

Giorno chiediGiorno(){
   while(true) {
    cout << "Inserisci il giorno:" << endl;
    cout << "0) lunedi" << endl;
    cout << "1) martedi" << endl;
    cout << "2) mercoledi" << endl;
    cout << "3) giovedi" << endl;
    cout << "4) venerdi" << endl;
    cout << "5) sabato" << endl;
    cout << "6) domenica" << endl;
    cout << "? ";
    char c;
    cin >> c;
    int s = c - '0';
    if(s>=0 && s<=6)
      return (Giorno) s;
    cout << "Scelta inesistente" << endl;
  }
}

void stampaG(Giorno g) {
  const char* st[] = {"lunedi", "martedi", "mercoledi", "giovedi", "venerdi", "sabato", "domenica"};
  cout << st[g] << endl;
}

Alimento chiediAlimento(){
  Alimento p;
  cout << "Inserisci nome: ";
  cin >> p.nome;
  cout << "Inserisci calorie: ";
  cin >> p.calorie;
  cout << "Inserisci grammi: ";
  cin >> p.grammi;
  return p;
}

int main(){
  Dieta diet;
  inizializza(diet);
  if(carica(diet, "dati.txt"))
    cout << "Caricamento dati ok" << endl;
  char c;
  Alimento p;
  Giorno g;
  Tipo t;
  int k;
  char n[MAXN];
  const char nf[] = "prova.txt";
  while(true) {
    menu();
    cin >> c;
    switch(c) {
      case '1':
        t = chiediTipo();
        g = chiediGiorno();
        p = chiediAlimento();
        if(inserisci(diet, p, t, g)) cout << "inserimento ok" << endl;
        else cout << "non riesco a inserire" << endl;
        break; 
      case '2':
        g = chiediGiorno();
        stampa(diet, g);
        break;
      case '3':
        t = chiediTipo();
        g = piuCalorie(diet, t);
        stampaG(g);
        break;
      case '4':
        cout << "Inserisci nome alimento: ";
        cin >> n;
        k = quanteVolte(diet, n);
        cout << k << " volte" << endl;
        break;
      case '5':
        if(salva(diet, nf)){
          cout << "contenuto del file:" << endl;
          system("type prova.txt");
        } else {
          cout << "errore nella chiamata a salva()" << endl;
        }
        break;
      case '6':
        return 0;
      default:
        cout << "Scelta non valida" << endl;
    }
  }
}
