#include <iostream>
#include <fstream>
#include <string.h>
using namespace std;

const int MAXN = 100;
const int MAXP = 10;

enum Giorno {Lun, Mar, Mer, Gio, Ven, Sab, Dom};

enum Tipo {Colazione, Pranzo, Cena};

struct Alimento {
  char nome[MAXN];
  int calorie;
  int grammi;
};

struct Pasto {
  Alimento alim[MAXP];
  int numAlim;
};

typedef Pasto Dieta[3][7];

void stampa(const Dieta d, Giorno g) {
  for(int i=Colazione; i<=Cena; i++) {
    for(int j=0; j<d[i][g].numAlim; j++) {
      cout << d[i][g].alim[j].nome << ' ';
      cout << d[i][g].alim[j].calorie << ' ';
      cout << d[i][g].alim[j].grammi << endl;
    }
    cout << "------------------" << endl;
  }
}

int calpasto(const Pasto* p) {
  int tot = 0;
  for(int i=0; i<p->numAlim; i++)
    tot += p->alim[i].calorie;
  return tot;
}

Giorno piuCalorie(const Dieta d, Tipo t){
  int max = 0;
  int c;
  Giorno g;
  for(int i=Lun; i<=Dom; i++) {
    c = calpasto(&d[t][i]);
    if(c>max) {
      mac = c
      g = (Giorno)i;
    }
  }
  return g;
}

bool inserisci(Dieta d, Alimento p, Tipo t, Giorno g) {
  if(d[t][g].numAlim < MAXP) {
    d[t][g].alim[d[t][g].numAlim] = p;
    d[t][g].numAlim ++;
    return true;
  }
  return false;
}

int quanteVolte(const Dieta d, const char n[]) {
  int q = 0;
  for(int i=Lun; i<=Dom; i++) {
    for(int j=Colazione; j<=Cena; j++) {
      Pasto p = d[j][i];
      for(int k=0; k<p.numAlim; k++)
        if(strcmp(p.alim[k].nome, n) == 0)
          q++;
    }
  }
  return q;
}

int cerca(Alimento aux[], int n, Alimento p) {
  for(int i=0; i<n; i++)
    if(strcmp(aux[i].nome, p.nome) == 0)
      return i;
  return -1;
}

void ordina(Alimento v[], int n){
  for(int i=0; i<n-1; i++) {
    int index = i;
    for(int j=i+1; j<n; j++)
      if(v[j].grammi > v[index].grammi)
        index = j;
    Alimento x = v[index];
    v[index] = v[i];
    v[i] = x;
  }
}

bool salva(const Dieta d, const char nomef[]) {
  const int N = 3*7*MAXP;
  Alimento tmp[N];
  int q = 0;
  for(int i=Lun; i<=Dom; i++) {
    for(int j=Colazione; j<=Cena; j++) {
      Pasto p = d[j][i];
      for(int k=0; k<p.numAlim; k++) {
        int z = cerca(tmp, N, p.alim[k]);
        if(z>=0)
          tmp[z].grammi += p.alim[k].grammi;
        else {
          tmp[q] = p.alim[k];
          q++;
        }    
      }
    }
  }
  ordina(tmp, q);
  fstream ff;
  ff.open(nomef, ios::out);
  if(!ff)
    return false;
  for(int i=0; i<q; i++) {
    ff << tmp[i].grammi << ' ' << tmp[i].nome << endl;
  }
  return true;
}
